puts "#"
puts "# This tool makes t2e.cnf files for individual"
puts "# enterprise-Oid."
puts "#"
puts "#####################################################"

# process read line of file
proc getline { _fid _line _number } {
    upvar $_line _LINE
    upvar $_number _NUMBER
    if { [eof $_fid] != 0 } {
        return -1
    }
    incr _NUMBER
    return [gets $_fid _LINE]
}
set _number 0

# check argument
if { $argc < 1 } {
    puts "$argv0 input_file"
    exit
}

# open input file
set _input_file [lindex $argv 0]
set _in [open "$_input_file" ]

# read line of input file
while { [getline $_in _line _number] != -1 } {
    set _data [lindex $_line 3]
    if { [regexp -- {^Enterprise} $_data] == 0 } {
        # not start of definition
        continue
    }

    # start of definition
    puts $_line

    # get enterprise and dot
    regsub -- {^Enterprise=} $_data "" _enterprise
    set _dot_enterprise [lindex $_line 4]
    set _output_file [format "%s.cnf" $_enterprise]

    # config file is opened?
    if { [array names _files ${_enterprise}] == "" } {
        # create new file
        set _out [open "$_output_file" w]
        set _files($_enterprise) 1
        puts $_out "# enterprises=$_dot_enterprise"
        puts $_out ""
    } else {
        # add to file
        set _out [open "$_output_file" a]
    }

    puts $_out "# trap -> event conversion setup file"
    puts $_out "$_line"
    while { [getline $_in _line _number] != -1 } {
        puts $_out "$_line"
        if { [regexp {^[ \t]*#.*definition end[ \t]$} $_line] != 0 } {
            # end of definition
            break;
        }
    }
    puts $_out ""
    close $_out
}

# close input file
close $_in

