# converter between mib-name and dot-formation
# 
#   input 
#      -pathoperandŎw肳ꂽpXMIBt@C[hA
#      IvVȂ̈Ŏw肳ꂽOIDϊB
# 
#      ϐ  objname    c  Sobj-namelist
#                objdot     c  Sobjidlist
#                debug      c  fobOtO
# 
#                               

variable objname 
variable objdot 
variable debug 

set objname ""
set objdot  ""
set debug   0
	
##################################################################
proc showResult {input} {

	if { [regexp {^[0-9\.]+$} $input ] == 1 } {
		cnvdot2name $input
	} else {
		cnvname2dot $input
	}
	
	return

}


##################################################################
proc cnvdot2name {input} {

	global objname
	global objdot

	set result [ d2n $input ]
	if { $result != "not-match" } {
		showMessage "$result ($input) [ cnvD2NameL $input ] " 
	} else {
		showMessage "not match" 
	}

	return

}


##################################################################
proc cnvD2NameL {input} {

	global objname
	global objdot

	regsub -all {\.} $input " " idlist
	set numofids [llength $idlist]
	set index -1
	set result "


"
	set Blank "   "
	set result "
>>iso
"
	
	for { set i 1 } { $i < $numofids } { incr i } {
		set temptarget ""
		for { set j 0 } { $j <= $i } { incr j } {
			if {$j!=0} { append temptarget "." }
			append temptarget [lindex $idlist $j]
		}
		set index [lsearch -exact $objdot $temptarget]
		if { $index > 0 } then {
			append result $Blank
			append result "+-"
			append result [d2n $temptarget]
			append result "
"
		} else {
			append result $Blank
			append result "+-"
			append result [lindex $idlist $i]
			append result "
"
		}
		append Blank "   "
	}
	
	return $result 
}


##################################################################
proc d2n {input} {

	global objname
	global objdot

	regsub -all {\.} $input " " idlist
	set numofids [llength $idlist]
	set index -1
	for { set i $numofids } { $i > 0 } { incr i -1 } {
		set temptarget ""
		for { set j 0 } { $j < $i } { incr j } {
			if {$j!=0} { append temptarget "." }
			append temptarget [lindex $idlist $j]
		}
		set index [lsearch -exact $objdot $temptarget]
		if { $index > 0 } break 
	}
	if { $index > 0 } {
		set result [lindex $objname $index]
		for { set j $i } { $j < $numofids } { incr j } {
			append result "."
			append result [lindex $idlist $j]
		}
		return $result 
	} else {
		return "not-match" 
	}
}


##################################################################
proc cnvname2dot {input} {

	global objname
	global objdot
	global debug

	set index [ string first "." $input ]
	if { $index < 0 } {
		set tindex [lsearch $objname $input]
		if { $tindex > 0 } {
			set result [lindex $objdot $tindex]
			showMessage "$input ($result)  [ cnvD2NameL $result ] "
		} else {
			showMessage "not match" 
		}
	} else {
		set namepart [string range $input 0 [expr $index-1 ] ]
		set dotpart  [string range $input $index end]
		if { ${debug} == 1 } {
			puts stdout "namepart = $namepart"
			puts stdout "dotpart = $dotpart"
		}
		if { [regexp {^[0-9\.]*$} $dotpart ] == 0 } {
			showMessage "bad format"
		} else {
			set tindex [lsearch $objname $namepart]
			if { $tindex > 0 } {
				set result [lindex $objdot $tindex]
				set alldot $result
				append alldot $dotpart				
				showMessage "[d2n $alldot] ($alldot)  [ cnvD2NameL $alldot ] "
			} else {
				showMessage "not match" 
			}
		}
	}

	return

}

##################################################################
#
# showMessage
#      msgtxt : output message text
#
##################################################################
proc showMessage {msgtxt} {
	puts stdout ${msgtxt}
}

##################################################################
proc loadMibFile {mibdir} {

	global objname
	global objdot
	global debug

	if { [file exists $mibdir] == 0 } {
		puts stderr "directory ${mibdir} does not exist"
		exit
	}
	# path separators are converted platform separator to tcl separator
	set mibdir [file join ${mibdir}]

	# getting mib file list
	set mibfiles [glob -path ${mibdir}/ {*.[mM][iI][bB]}]

	foreach file ${mibfiles} {
		# Read xxx.MIB file,
		# and initialise obj name list and obj dot-format-id list.
		set mfileid [open "${file}" r]
		while { [eof ${mfileid}] == 0 } {
			gets ${mfileid} record
			regsub -all "," ${record} " " record
			if { [lsearch -exact $objname [lindex ${record} 0] ] } {
				lappend objname [lindex ${record} 0]
				lappend objdot  [lindex ${record} 1]
			}
		}
		close ${mfileid}
		if { ${debug} } {
			puts stdout " file : ${file} processed."
		}
	}
}

##################################################################
proc usage {} {
	# output usage and exit
	puts stderr "Usage: command -path mibdir oid"
	exit
}

##################################################################
# main
##################################################################

# check parameter
	for { set i 0 } { ${argc} > ${i} } { incr i } {
		switch -- [lindex ${argv} ${i}] {
			{-x} {
				# debug mode
				set debug 1 
			}
			{-path} {
				# directory of mib files
				incr i
				if { ${argc} == ${i} } {
					usage
				}
				set mibdir [lindex ${argv} ${i}]
				if { ${debug} } { puts ${mibdir} }
			}
			{-stdin} {
				# mib is specified standard input
				set std_input 1
			}
			default {
				# other. maybe mib oid
				lappend oids [lindex ${argv} ${i}]
				if { ${debug} } { puts ${oids} }
			}
		}
	}
	if { [info exists mibdir] == 0 } {
		usage
	}

	# output separator
	set separator [string repeat - 60]
	if { [info exists std_input] && ${std_input} } {
		# oid operand is specified by standard input
		loadMibFile ${mibdir}
		while {1} {
			puts ${separator}
			puts -nonewline "OID?> "
			flush stdout
			if { [gets stdin oid] < 1 } {
				break
			}
			showResult ${oid}
		}
	} else {
		# oid operand is specified by command line
		if { [info exists oids] != 1 } {
			# oid operands does not exist at all
			usage
		}
		loadMibFile ${mibdir}
		# oid loop
		foreach input ${oids} {
			puts ${separator}
			showResult ${input}
		}
	}

# EOF

